// app.c

#define UNICODE
#define _UNICODE

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "gameport.h"
#include "joystick.h"

VOID main(IN int argc, IN char *argv[])
{
    HANDLE hGamePort, hJoy0, hJoy1;
    BYTE data;
    int ret;
    JOY_DATA joyData;

    // Send request directly to GamePort device object.

    hGamePort = CreateFile(GAMEPORT_WIN32_NAME, GENERIC_READ | 
                           GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 
                           FILE_ATTRIBUTE_NORMAL, NULL);

    if (ReadFile(hGamePort, &data, 1, &ret, NULL)) {    
        data &= 0xf0;      // mask high four bits
        data ^= 0xf0;      // invert the bit sense
        printf("GamePort Button Data: %x\n", data);
    }


    // Send request to each of the JoyStick device objects.

    hJoy0 = CreateFile(JOYSTICK0_WIN32_NAME, GENERIC_READ | 
                       GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 
                       FILE_ATTRIBUTE_NORMAL, NULL);

    hJoy1 = CreateFile(JOYSTICK1_WIN32_NAME, GENERIC_READ | 
                       GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 
                       FILE_ATTRIBUTE_NORMAL, NULL);

    if (ReadFile(hJoy0,&joyData,sizeof(JOY_DATA),&ret,NULL)) {
        printf("JoyStick1: Button1=%d, Button2=%d\n", 
               joyData.Button1, joyData.Button2);
    }

    if (ReadFile(hJoy1,&joyData,sizeof(JOY_DATA),&ret,NULL)) {
        printf("JoyStick2: Button1=%d, Button2=%d\n", 
               joyData.Button1, joyData.Button2);
    }

    CloseHandle(hGamePort);
    CloseHandle(hJoy0);
    CloseHandle(hJoy1);
} // main
