// SnoopVw.h : interface of the CSnoopView class
//
////////////////////////////////////////////////////////////////

#ifndef _SNOOPVW_H_
#define _SNOOPVW_H_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CSnoopView : public CFormView
{
protected: // create from serialization only
    CSnoopView();
    DECLARE_DYNCREATE(CSnoopView)

public:
    //{{AFX_DATA(CSnoopView)
    enum { IDD = IDD_SNOOP_FORM };
    CButton     m_buttSnoop;
    CEdit       m_editAddress;
    CListBox    m_listData;
    CComboBox   m_comboWindow;
    CComboBox   m_comboClass;
    //}}AFX_DATA

// Attributes
public:
    CSnoopDoc* GetDocument();

// Operations
public:

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CSnoopView)
    public:
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    virtual void OnInitialUpdate();
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    //}}AFX_VIRTUAL

// Implementation
public:
    virtual ~CSnoopView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
    //{{AFX_MSG(CSnoopView)
    afx_msg void OnChange();
    afx_msg void OnBSnoop();
    afx_msg void OnBRefresh();
    //}}AFX_MSG

    void    FillClassCombo();
    void    FillWindowCombo();
    BOOL    GetInput(LPBYTE& pBase, CString& sClass);

    BOOL    DisplayCString(LPBYTE pbyBase, LPVOID pS);
    BOOL    DisplayCWordArray(LPBYTE pbyBase, LPVOID pWA);
    BOOL    DisplayCStringArray(LPBYTE pbyBase, LPVOID pSA);
    BOOL    DisplayCMapStringToString(LPBYTE pbyBase, LPVOID pMSS);

    CString GetCString(LPBYTE pbyBase);
    BOOL    ReadMemory(LPBYTE pbyBase, LPVOID pOut, int nSize);

    DECLARE_MESSAGE_MAP()

    static CString m_sStaticWindowText;
    HANDLE  m_hProcess;
};

#ifndef _DEBUG  // debug version in SnoopVw.cpp
inline CSnoopDoc* CSnoopView::GetDocument()
   { return (CSnoopDoc*)m_pDocument; }
#endif

//////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}

#endif

